package com.objis.demohibernate.dao;
import org.hibernate.Session;
import org.hibernate.StaleObjectStateException;

import com.objis.demohibernate.domaine.Event;
import com.objis.demohibernate.exception.DataAccesException;
import com.objis.demohibernate.util.HibernateUtil;

//COUCHE DAO
//TODO : Proposez refactoring du code 
//pour qu'il ressemble +  une couche DA0 digne de ce nom.  
//Proposez au moins 2 meilleures pratiques

public class EventDao {

	public Long createEvent(Event event){

		Session session = HibernateUtil.getSessionFactory().getCurrentSession(); 

	    Long id = (Long)session.save(event);
		
		return id;
		
	}
	public Event getEvent(Long id){

		Session session = HibernateUtil.getSessionFactory().getCurrentSession(); 

		session.beginTransaction();
		
	    Event event = (Event)session.get(Event.class, id); 
		
	  //  session.getTransaction().commit();
	    
		return event;
		
	}
	
	public void updateEvent(Event event) throws DataAccesException{

		Session session = HibernateUtil.getSessionFactory().getCurrentSession(); 
		try {
			session.saveOrUpdate(event);
		} catch (StaleObjectStateException e) {
			System.out.println("MAUVAIS ETAT !!!!!!!!!");
		}
	     
	}
	
	public void mergeEvent(Event event){

		Session session = HibernateUtil.getSessionFactory().getCurrentSession(); 

	     session.merge(event);
		
	}
}
