package com.objis.demohibernate.service;

import org.hibernate.Session;

import com.objis.demohibernate.dao.EventDao;
import com.objis.demohibernate.domaine.Event;
import com.objis.demohibernate.exception.DataAccesException;
import com.objis.demohibernate.util.HibernateUtil;

// COUCHE SERVICE
// TODO : Proposez refactoring du code 
// pour qu'il ressemble +  une couche mtier digne de ce nom. 
// En particulier sans code technique. 
// Proposez au moins 2 meilleures pratiques

public class GestionnaireEvent {
	
EventDao eventDao = new EventDao();

public Long creerEvent(Event event){
	
	try {
		// Commencer unit de travail . getCurrentSession() est la marque de la propagation de Session
		HibernateUtil.getSessionFactory().getCurrentSession().beginTransaction();
		
		Long id = (Long) eventDao.createEvent(event);
		System.out.println("Cl primaire Event : " + id);
		
		HibernateUtil.getSessionFactory().getCurrentSession().getTransaction().commit(); 
		
		return id;
		
	} catch (RuntimeException ex) {
		try {
			HibernateUtil.getSessionFactory().getCurrentSession().getTransaction().rollback();
			} catch (RuntimeException rbEx) {
			System.out.println("Ne peux faire de RollBack");
			}
			throw ex;
	}
	
}


public Event obtenirEvent(Long id){
	
	try {
		// Commencer unit de travail . getCurrentSession() est la marque de la propagation de Session
		HibernateUtil.getSessionFactory().getCurrentSession().beginTransaction();
		
		Event event = eventDao.getEvent(id);
		
		HibernateUtil.getSessionFactory().getCurrentSession().getTransaction().commit(); 

		return event;
		
	} catch (RuntimeException ex) {
		try {
			HibernateUtil.getSessionFactory().getCurrentSession().getTransaction().rollback();
			} catch (RuntimeException rbEx) {
			System.out.println("Ne peux faire de RollBack");
			}
			throw ex;
	}
	
}

public void miseAjourEvent(Event event){
	
	try {
		// Commencer unit de travail . getCurrentSession() est la marque de la propagation de Session
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		
		session.beginTransaction();
		
		//Reattacher l'objet
		eventDao.updateEvent(event);
		
		session.getTransaction().commit(); 

	} catch (RuntimeException ex) {
		try {
			HibernateUtil.getSessionFactory().getCurrentSession().getTransaction().rollback();
			} catch (RuntimeException rbEx) {
			System.out.println("Ne peux faire de RollBack");
			}
			throw ex;
	} catch(DataAccesException ex) {
		ex.printStackTrace();
	}
	
}

public void miseAjourForceeEvent(Event event){
	
	try {
		// Commencer unit de travail . getCurrentSession() est la marque de la propagation de Session
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		
		session.beginTransaction();
		
		//Reattacher l'objet
		eventDao.mergeEvent(event);
		
		session.getTransaction().commit(); 

	} catch (RuntimeException ex) {
		try {
			HibernateUtil.getSessionFactory().getCurrentSession().getTransaction().rollback();
			} catch (RuntimeException rbEx) {
			System.out.println("Ne peux faire de RollBack");
			}
			throw ex;
	}
	
}
}
